<template>
  <div class="card shadow"
       :class="type === 'dark' ? 'bg-default': ''">
    <div class="card-header border-0"
         :class="type === 'dark' ? 'bg-transparent': ''">
      <div class="row align-items-center">
        <div class="col">
          <h3 class="mb-0" :class="type === 'dark' ? 'text-white': ''">
            {{title}}
          </h3>
        </div>
        <div class="col text-right">
          <router-link class="btn btn-lg btn-primary" :to="`/manage/create`">Create User</router-link>
        </div>
      </div>
    </div>

    <div class="table-responsive">
      <base-table class="table align-items-center table-flush"
                  :class="type === 'dark' ? 'table-dark': ''"
                  :thead-classes="type === 'dark' ? 'thead-dark': 'thead-light'"
                  tbody-classes="list"
                  :data="tableData">
        <template slot="columns">
          <th>No.</th>
          <th>Username</th>
          <th>First name</th>
          <th>Last name</th>
          <th>E-mail</th>
          <th>Organization</th>
          <th>User roll</th>
          <th>Status</th>
          <th>Manage</th>
        </template>

        <template slot-scope="{row,index}">
         <td>{{index+1}}</td>
          <td class="budget">
            {{row.username}}
          </td>
          <td>
          {{row.firstname}}
          </td>
          <td>
            {{row.lastname}}
          </td>
          <td>
            {{row.email}}
          </td>
          <td>
            {{row.organization_name}}
          </td>
          <td>
            <span class="text-success" v-if="row.user_roll === 1">
              Admin
          </span>
          <span class="text-info" v-else>
              Guest
          </span>
          </td>
          <td>
          <span class="text-success" v-if="row.active === 1">
              Enable
          </span>
          <span class="text-danger" v-else>
              Disable
          </span>
          </td>

          <td class="text-right">
            <base-dropdown class="dropdown"
                           position="right">
              <a slot="title" class="btn btn-sm btn-icon-only text-light" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                <i class="fas fa-ellipsis-v"></i>
              </a>

              <template>
                <router-link class="dropdown-item" :to="`/manage/profile/${row.user_id}`">Edit</router-link>
                <router-link class="dropdown-item" :to="`/manage/change/${row.user_id}`">Change Password</router-link>
                <div v-if="user_id != row.user_id && row.user_roll !== 1">
                  <a class="dropdown-item" href="#" v-if="row.active === 1" @click="disable(row.user_id)">Disable</a>
                  <a class="dropdown-item" href="#" v-else @click="enable(row.user_id)">Enable</a>
                </div>
              </template>
            </base-dropdown>
          </td>

        </template>

      </base-table>
    </div>

    <div class="card-footer d-flex justify-content-end"
         :class="type === 'dark' ? 'bg-transparent': ''">
      <base-pagination></base-pagination>
    </div>

  </div>
</template>
<script>
 export default {
    name: 'projects-table',
    props: {
      type: {
        type: String
      },
      title: String
    },
    data() {
      return {
        tableData: [],
        user_id : localStorage.user_id
      }
    },
    created() {
      if (localStorage.token !== 'undefined') {
        this.getUser()
      }else{
        this.checkCurrentLogin()
      }
      },
      methods: {
        checkCurrentLogin () {
          if(localStorage.token !== ''){
            this.$router.replace('/topic')
          }else{
            this.$router.replace('/login')
          }
        },
        getUser() {
          this.$http.get('/manage/users',{
          headers: {
            Authorization: 'Bearer ' + localStorage.token
            }
          })
          .then(response => (this.tableData = response.data.users))
          .catch(() => this.checkCurrentLogin ())
        },
        disable(user_id){
          this.$swal({
            title: "Disable user?",
            icon: "warning",
            buttons: ['cancel','confirm'],
            dangerMode: true,
          })
          .then((confirm) => {
          if (confirm) {
            this.$http.post('/manage/users/disable',{
                user_id : user_id,
                active : 0
            })
          .then(response => {
              if(response.data.message === 'success'){
                this.$swal({
                    title: "Disabled!",
                    icon: "success",
                    timer: 3000
                })
                this.getUser()
              }
          })
          .catch(() => this.checkEdituser ())
            }
          })
        },
        enable(user_id){
          this.$swal({
            title: "Enable user?",
            icon: "warning",
            buttons: ['cancel','confirm']
          })
          .then((confirm) => {
          if (confirm) {
            this.$http.post('/manage/users/disable',{
                user_id : user_id,
                active : 1
            })
          .then(response => {
              if(response.data.message === 'success'){
                this.$swal({
                    title: "Enabled!",
                    icon: "success",
                    timer: 3000
                })
                this.getUser()
              }
          })
          .catch(() => this.checkEdituser ())
            }
          })
        }
      },
  }
</script>
<style>
</style>
